You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

516 lines
13 KiB

  1. #!/bin/bash
  2. . /etc/shlib
  3. include common
  4. include parse
  5. include cmdline
  6. include config
  7. include cache
  8. include fn
  9. [[ "${BASH_SOURCE[0]}" != "${0}" ]] && SOURCED=true
  10. version=0.1
  11. desc='Install backup'
  12. help=""
  13. docker:running-container-projects() {
  14. :cache: scope=session
  15. docker ps --format '{{.Label "com.docker.compose.project"}}' | sort | uniq
  16. }
  17. decorator._mangle_fn docker:running-container-projects
  18. ssh:mk-private-key() {
  19. local host="$1" service_name="$2"
  20. (
  21. settmpdir VPS_TMPDIR
  22. ssh-keygen -t rsa -N "" -f "$VPS_TMPDIR/rsync_rsa" -C "$service_name@$host" >/dev/null
  23. cat "$VPS_TMPDIR/rsync_rsa"
  24. )
  25. }
  26. mailcow:has-images-running() {
  27. local images
  28. images=$(docker ps --format '{{.Image}}' | sort | uniq)
  29. [[ $'\n'"$images" == *$'\n'"mailcow/"* ]]
  30. }
  31. mailcow:has-container-project-mentionning-mailcow() {
  32. local projects
  33. projects=$(docker:running-container-projects) || return 1
  34. [[ $'\n'"$projects"$'\n' == *mailcow* ]]
  35. }
  36. mailcow:has-running-containers() {
  37. mailcow:has-images-running ||
  38. mailcow:has-container-project-mentionning-mailcow
  39. }
  40. mailcow:get-root() {
  41. :cache: scope=session
  42. local dir
  43. for dir in {/opt{,/apps},/root}/mailcow-dockerized; do
  44. [ -d "$dir" ] || continue
  45. [ -r "$dir/mailcow.conf" ] || continue
  46. echo "$dir"
  47. return 0
  48. done
  49. return 1
  50. }
  51. decorator._mangle_fn mailcow:get-root
  52. compose:get-compose-yml() {
  53. :cache: scope=session
  54. local path
  55. [ -e "/etc/compose/local.conf" ] && . "/etc/compose/local.conf"
  56. path=${DEFAULT_COMPOSE_FILE:-/etc/compose/compose.yml}
  57. [ -e "$path" ] || return 1
  58. echo "$path"
  59. }
  60. decorator._mangle_fn compose:get-compose-yml
  61. compose:has-container-project-myc() {
  62. local projects
  63. projects=$(docker:running-container-projects) || return 1
  64. [[ $'\n'"$projects"$'\n' == *$'\n'"myc"$'\n'* ]]
  65. }
  66. type:is-mailcow() {
  67. mailcow:get-root >/dev/null ||
  68. mailcow:has-running-containers
  69. }
  70. type:is-compose() {
  71. compose:get-compose-yml >/dev/null &&
  72. compose:has-container-project-myc
  73. }
  74. vps:get-type() {
  75. local fn
  76. for fn in $(declare -F | cut -f 3 -d " " | egrep "^type:is-"); do
  77. "$fn" && {
  78. echo "${fn#type:is-}"
  79. return 0
  80. }
  81. done
  82. return 1
  83. }
  84. mirror-dir:sources() {
  85. :cache: scope=session
  86. if ! shyaml get-values default.sources < /etc/mirror-dir/config.yml; then
  87. err "Couldn't query 'default.sources' in '/etc/mirror-dir/config.yml'."
  88. return 1
  89. fi
  90. }
  91. decorator._mangle_fn mirror-dir:sources
  92. mirror-dir:check-add() {
  93. local elt="$1" sources
  94. sources=$(mirror-dir:sources) || return 1
  95. if [[ $'\n'"$sources"$'\n' == *$'\n'"$elt"$'\n'* ]]; then
  96. info "Volume $elt already in sources"
  97. else
  98. Elt "Adding directory $elt"
  99. sed -i "/sources:/a\ - \"${elt}\"" \
  100. /etc/mirror-dir/config.yml
  101. Feedback || return 1
  102. fi
  103. }
  104. mirror-dir:check-add-vol() {
  105. local elt="$1"
  106. mirror-dir:check-add "/var/lib/docker/volumes/*_${elt}-*/_data"
  107. }
  108. ## The first colon is to prevent auto-export of function from shlib
  109. : ; bash-bug-5() { { cat; } < <(e) >/dev/null; ! cat "$1"; } && bash-bug-5 <(e) 2>/dev/null &&
  110. export BASH_BUG_5=1 && unset -f bash_bug_5
  111. wrap() {
  112. local label="$1" code="$2"
  113. shift 2
  114. export VERBOSE=1
  115. interpreter=/bin/bash
  116. if [ -n "$BASH_BUG_5" ]; then
  117. (
  118. settmpdir tmpdir
  119. fname=${label##*/}
  120. e "$code" > "$tmpdir/$fname" &&
  121. chmod +x "$tmpdir/$fname" &&
  122. Wrap -vsd "$label" -- "$interpreter" "$tmpdir/$fname" "$@"
  123. )
  124. else
  125. Wrap -vsd "$label" -- "$interpreter" <(e "$code") "$@"
  126. fi
  127. }
  128. mailcow:install-backup() {
  129. local BACKUP_SERVER="$1" mailcow_root DOMAIN
  130. ## find installation
  131. mailcow_root=$(mailcow:get-root) || {
  132. err "Couldn't find a valid mailcow root directory."
  133. return 1
  134. }
  135. ## check ok
  136. DOMAIN=$(cat "$mailcow_root/.env" | grep ^MAILCOW_HOSTNAME= | cut -f 2 -d =) || {
  137. err "Couldn't find MAILCOW_HOSTNAME in file \"$mailcow_root/.env\"."
  138. return 1
  139. }
  140. MYSQL_ROOT_PASSWORD=$(cat "$mailcow_root/.env" | grep ^DBROOT= | cut -f 2 -d =) || {
  141. err "Couldn't find DBROOT in file \"$mailcow_root/.env\"."
  142. return 1
  143. }
  144. MYSQL_CONTAINER=${MYSQL_CONTAINER:-mailcowdockerized_mysql-mailcow_1}
  145. container_id=$(docker ps -f name="$MYSQL_CONTAINER" --format "{{.ID}}")
  146. if [ -z "$container_id" ]; then
  147. err "Couldn't find docker container named '$MYSQL_CONTAINER'."
  148. return 1
  149. fi
  150. export MYSQL_ROOT_PASSWORD
  151. export MYSQL_CONTAINER
  152. export BACKUP_SERVER
  153. export DOMAIN
  154. wrap "Install rsync-backup on host" "
  155. cd /srv/charm-store/rsync-backup
  156. bash ./hooks/install.d/60-install.sh
  157. " || return 1
  158. wrap "Mysql dump install" "
  159. cd /srv/charm-store/mariadb
  160. bash ./hooks/install.d/60-backup.sh
  161. " || return 1
  162. ## Using https://github.com/mailcow/mailcow-dockerized/blob/master/helper-scripts/backup_and_restore.sh
  163. for elt in "vmail{,-attachments-vol}" crypt redis rspamd postfix; do
  164. mirror-dir:check-add-vol "$elt" || return 1
  165. done
  166. mirror-dir:check-add "$mailcow_root" || return 1
  167. mirror-dir:check-add "/var/backups/mysql" || return 1
  168. mirror-dir:check-add "/etc" || return 1
  169. dest="$BACKUP_SERVER"
  170. dest="${dest%/*}"
  171. dest="${dest%%:*}"
  172. info "You should add key on '$dest' host:"
  173. echo compose-add-rsync-key -R "\"$DOMAIN\"" "\"$(cat /var/lib/rsync/.ssh/id_rsa.pub)\""
  174. }
  175. compose:install-backup() {
  176. local BACKUP_SERVER="$1" service_name="$2" compose_file="$3" force="$4"
  177. ## XXXvlab: far from perfect as it mimics and depends internal
  178. ## logic of current default way to get a domain in compose-core
  179. host=$(hostname)
  180. if ! egrep "^$host:" "$compose_file" >/dev/null &&
  181. ! egrep "^\s+domain:\s+$host\s*$" "$compose_file" >/dev/null; then
  182. err "Can't find domain '$host' in compose file '$compose_file'."
  183. return 1
  184. fi
  185. ip=$(getent ahosts "$host" | egrep "^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\s+" |
  186. head -n 1 | cut -f 1 -d " ") || return 1
  187. my_ip=$(curl -s myip.kal.fr)
  188. if [ "$ip" != "$my_ip" ]; then
  189. if [ -n "$force" ]; then
  190. warn "IP of '$host' ($ip) doesn't match mine ($my_ip). Ignoring due to ``-f`` option."
  191. else
  192. err "IP of '$host' ($ip) doesn't match mine ($my_ip). Use ``-f`` to force."
  193. return 1
  194. fi
  195. fi
  196. if [ -e "/root/.ssh/rsync_rsa" ]; then
  197. warn "deleting private key in /root/.ssh/rsync_rsa, has we are not using it anymore."
  198. rm -fv /root/.ssh/rsync_rsa
  199. fi
  200. if [ -e "/root/.ssh/rsync_rsa.pub" ]; then
  201. warn "deleting public key in /root/.ssh/rsync_rsa.pub, has we are not using it anymore."
  202. rm -fv /root/.ssh/rsync_rsa.pub
  203. fi
  204. if service_cfg=$(cat "$compose_file" |
  205. shyaml get-value -y "$service_name" 2>/dev/null); then
  206. info "Entry for service ${DARKYELLOW}$service_name${NORMAL}" \
  207. "is already present in '$compose_file'."
  208. cfg=$(e "$service_cfg" | shyaml get-value -y options) || {
  209. err "No ${WHITE}options${NORMAL} in ${DARKYELLOW}$service_name${NORMAL}'s" \
  210. "entry in '$compose_file'."
  211. return 1
  212. }
  213. private_key=$(e "$cfg" | shyaml get-value private-key)
  214. target=$(e "$cfg" | shyaml get-value target)
  215. if [ "$target" != "$BACKUP_SERVER" ]; then
  216. err "Existing backup target '$target' is different" \
  217. "from specified '$BACKUP_SERVER'"
  218. return 1
  219. fi
  220. else
  221. private_key=$(ssh:mk-private-key "$host" "$service_name")
  222. cat <<EOF >> "$compose_file"
  223. $service_name:
  224. options:
  225. ident: $host
  226. target: $BACKUP_SERVER
  227. private-key: |
  228. $(e "$private_key" | sed -r 's/^/ /g')
  229. EOF
  230. fi
  231. info "You can run this following command on $BACKUP_SERVER:"
  232. public_key=$(ssh-keygen -y -f <(e "$private_key"$'\n'))
  233. echo "compose-add-rsync-key -R '$host' '$public_key ${service_name}@$host'"
  234. }
  235. [ "$SOURCED" ] && return 0
  236. ##
  237. ## Command line processing
  238. ##
  239. cmdline.spec.gnu
  240. cmdline.spec.reporting
  241. cmdline.spec.gnu install
  242. cmdline.spec::cmd:install:run() {
  243. :
  244. }
  245. cmdline.spec.gnu get-type
  246. cmdline.spec::cmd:get-type:run() {
  247. vps:get-type
  248. }
  249. cmdline.spec:install:cmd:backup:run() {
  250. : :posarg: BACKUP_SERVER 'Target backup server'
  251. local vps_type
  252. vps_type=$(vps:get-type) || {
  253. err "Failed to get type of installation."
  254. return 1
  255. }
  256. if ! fn.exists "${vps_type}:install-backup"; then
  257. err "type '${vps_type}' has no backup installation implemented yet."
  258. return 1
  259. fi
  260. "cmdline.spec:install:cmd:$vps_type-backup:run" "$BACKUP_SERVER"
  261. }
  262. DEFAULT_BACKUP_SERVICE_NAME=rsync-backup
  263. cmdline.spec:install:cmd:compose-backup:run() {
  264. : :posarg: BACKUP_SERVER 'Target backup server'
  265. : :optval: --service-name,-s "YAML service name in compose
  266. file to check for existence of key.
  267. Defaults to '$DEFAULT_BACKUP_SERVICE_NAME'"
  268. : :optval: --compose-file,-f "Compose file location. Defaults to
  269. the value of '\$DEFAULT_COMPOSE_FILE'"
  270. : :optval: --force,-F "Compose file location. Defaults to
  271. the value of '\$DEFAULT_COMPOSE_FILE'"
  272. local service_name compose_file
  273. [ -e "/etc/compose/local.conf" ] && source /etc/compose/local.conf
  274. compose_file=${opt_compose_file:-$DEFAULT_COMPOSE_FILE}
  275. service_name=${opt_service_name:-$DEFAULT_BACKUP_SERVICE_NAME}
  276. if ! [ -e "$compose_file" ]; then
  277. err "Compose file not found in '$compose_file'."
  278. return 1
  279. fi
  280. compose:install-backup "$BACKUP_SERVER" "$service_name" "$compose_file" "$opt_force"
  281. }
  282. cmdline.spec:install:cmd:mailcow-backup:run() {
  283. : :posarg: BACKUP_SERVER 'Target backup server'
  284. "mailcow:install-backup" "$BACKUP_SERVER"
  285. }
  286. cmdline.spec.gnu backup
  287. cmdline.spec::cmd:backup:run() {
  288. local vps_type
  289. vps_type=$(vps:get-type) || {
  290. err "Failed to get type of installation."
  291. return 1
  292. }
  293. if ! fn.exists "cmdline.spec:backup:cmd:${vps_type}:run"; then
  294. err "type '${vps_type}' has no backup process implemented yet."
  295. return 1
  296. fi
  297. "cmdline.spec:backup:cmd:${vps_type}:run"
  298. }
  299. cmdline.spec:backup:cmd:mailcow:run() {
  300. local cmd_line cron_line cmd
  301. for f in mysql-backup mirror-dir; do
  302. [ -e "/etc/cron.d/$f" ] || {
  303. err "Can't find '/etc/cron.d/$f'." \
  304. "Have you forgotten to run 'vps install backup BACKUP_HOST' ?"
  305. return 1
  306. }
  307. if ! cron_line=$(cat "/etc/cron.d/$f" |
  308. grep -v "^#" | grep "\* \* \*"); then
  309. err "Can't find cron_line in '/etc/cron.d/$f'." \
  310. "Have you modified it ?"
  311. return 1
  312. fi
  313. cron_line=${cron_line%|*}
  314. cmd_line=(${cron_line#*root})
  315. if [ "$f" == "mirror-dir" ]; then
  316. cmd=()
  317. for arg in "${cmd_line[@]}"; do
  318. [ "$arg" != "-q" ] && cmd+=("$arg")
  319. done
  320. else
  321. cmd=("${cmd_line[@]}")
  322. fi
  323. code="${cmd[*]}"
  324. echo "${WHITE}Launching:${NORMAL} ${code}"
  325. {
  326. {
  327. (
  328. ## Some commands are using colors that are already
  329. ## set by this current program and will trickle
  330. ## down unwantedly
  331. ansi_color no
  332. eval "${code}"
  333. ) | sed -r "s/^/ ${GRAY}|${NORMAL} /g"
  334. set_errlvl "${PIPESTATUS[0]}"
  335. } 3>&1 1>&2 2>&3 | sed -r "s/^/ $DARKRED\!$NORMAL /g"
  336. set_errlvl "${PIPESTATUS[0]}"
  337. } 3>&1 1>&2 2>&3
  338. if [ "$?" != "0" ]; then
  339. err "Failed."
  340. return 1
  341. fi
  342. done
  343. info "Mysql backup and subsequent mirror-dir ${DARKGREEN}succeeded${NORMAL}."
  344. }
  345. set_errlvl() { return "${1:-1}"; }
  346. cmdline.spec:backup:cmd:compose:run() {
  347. local cron_line args
  348. if ! cron_line=$(docker exec myc_cron_1 cat /etc/cron.d/rsync-backup | grep "\* \* \*"); then
  349. err "Can't find cron_line in cron container." \
  350. "Have you forgotten to run 'compose up' ?"
  351. exit 1
  352. fi
  353. cron_line=${cron_line%|*}
  354. cron_line=${cron_line%"2>&1"*}
  355. cmd_line="${cron_line#*root}"
  356. eval "args=($cmd_line)"
  357. ## should be last argument
  358. docker_cmd=$(echo ${args[@]: -1})
  359. if ! [[ "$docker_cmd" == "docker run --rm -e "* ]]; then
  360. echo "docker command found should start with 'docker run'." >&2
  361. echo "Here's command:" >&2
  362. echo " $docker_cmd" >&2
  363. exit 1
  364. fi
  365. echo "${WHITE}Launching:${NORMAL} docker exec -i myc_cron_1 $docker_cmd"
  366. {
  367. {
  368. eval "docker exec -i myc_cron_1 $docker_cmd" | sed -r "s/^/ ${GRAY}|${NORMAL} /g"
  369. set_errlvl "${PIPESTATUS[0]}"
  370. } 3>&1 1>&2 2>&3 | sed -r "s/^/ $DARKRED\!$NORMAL /g"
  371. set_errlvl "${PIPESTATUS[0]}"
  372. } 3>&1 1>&2 2>&3
  373. if [ "$?" != "0" ]; then
  374. err "Failed."
  375. return 1
  376. fi
  377. info "mirror-dir ${DARKGREEN}succeeded${NORMAL}."
  378. }
  379. cmdline::parse "$@"